package bg.bas.dcl.entities;

import java.util.ArrayList;


public class Clause extends ArrayList<Word> {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	String id = "";
	String bulAux = " съм, ща, нямам, няма, ";
	String bulModal = " мога, трябва, може, започвам, започна, " +
			"почна, почвам, понечвам, понеча, " +
			"продължавам, продължа, спирам, спра, " +
			"преставам, престана, следвам, следва, ";
	String enAux = " be, have, will, shall, ";
	String enModal = " ";
	
	public NounPhraseWords subject = new NounPhraseWords();

	
	public ArrayList<Word> getFullVerbForm(){
		ArrayList<Word> vf = new ArrayList<Word>();
		
		for (Word w : this) {
			if (!w.verbID.equals("")) {
				vf.add(w);
			}
 		}
		
		return vf;
		
	}
	
	public Word getMeaningVerb(){
		
		
		for (Word w : this) {
			if (!w.verbID.equals("")) {
				
				if (w.pos.startsWith("V")
						&& !bulAux.contains(w.lemma)
						&& !bulModal.contains(w.lemma)
						&& !enAux.contains(w.lemma)
						&& !enModal.contains(w.lemma) )
				return w;
			}
 		}
		
		return null;
		
	}
	
	public String toString(){
		
		String result = "";
		for (Word w : this) {
			result += w.wordform + " ";
		}
		
		return result.trim();
	}

	public String toStringWithRefs(){
		
		String result = "";
		for (Word w : this) {
			result += w.wordform 
					+ (w.reference!=null? "(" +w.reference.wordform+ ")": "")
					+ " ";
		}
		
		return result.trim();
	}

	public int getNumberOf(String pos){
		
		int ctr = 0;
		
		for(Word w : this) if (w.pos.startsWith(pos)) ctr++;
		
		return ctr;
		
	}
	public ArrayList<Word> getAllPos(String pos){
		
		ArrayList<Word> res = new ArrayList<Word>();
		
		for(Word w : this) if (w.pos.startsWith(pos)) res.add(w);
		
		return res;
		
	}
	
	public ArrayList<Word> getAllPosBetweenPunct(String pos){
		
		ArrayList<Word> res = new ArrayList<Word>();
		
		for(int i = 0; i < size(); i++) {
			Word w = get(i);
			
			if (w.lemma.equals("българка")) {
				System.out.println("CL: "+toString());
				System.out.println("POS: "+w.pos);
				System.out.println("VERB: "+isBeforeVerb(w));
				System.out.println("IND: "+i);
				System.out.println("LIST SIZE: "+res.size());
				
			}
			
			if (w.pos.equals("U")){ 
//				System.out.println("CHECK0");

				if (isBeforeVerb(w)) {
					res = new ArrayList<Word>();
				} else {
					return res;
				}
			}
			
//			System.out.println("POS: "+w.pos);
//			System.out.println("VERB: "+isBeforeVerb(w));
			if (w.pos.startsWith(pos) && isBeforeVerb(w)){
//				System.out.println("CHECK1");
				
				int start = i;
				for (int j = i-1; j>=0; j--){
//					System.out.println("CHECK2"+j);

					if (get(j).pos.startsWith("A")) start=j;
					else break;
				}
				if (start == 0 || !get(start-1).pos.equals("R")) {
//					System.out.println("CHECK3");

					if (isBeforeVerb(w)) {
						res = new ArrayList<Word>();
					}
					res.add(w);
				}
				

				
			}else{
				if (w.pos.startsWith(pos)) {
					
					res.add(w);
				}
			}

			/**
			if (w.lemma.equals("българка")) {
				
				System.out.println("IND: "+i);
				System.out.println("LIST SIZE: "+res.size());
				System.exit(0);
			}
			*/

		}
		
		return res;
		
	}

	
	public boolean isBeforeVerb(Word w){

		for (Word v : this){
			if (!v.verbID.equals("")) return false;

			if (v.wordform.equals(w.wordform)) return true;
		}
		
		return false;
		
	}

	public boolean isAfter(Word w, String pos){

		for (int i = 0 ; i < size(); i++){
			Word v = get(i);
			
			if (v.wordform.equals(w.wordform)
					&& i > 0 && get(i-1).pos.startsWith(pos)) return true;
		}
		
		return false;
		
	}

	public boolean isAfterPrep(Word w){

		for (int i = 0 ; i < size(); i++){
			Word v = get(i);
			
			if (v.wordform.equals(w.wordform)
					&& i > 0 && get(i-1).pos.startsWith("R")) return true;
			if (v.wordform.equals(w.wordform)
					&& i > 1 
					&& get(i-1).pos.startsWith("A")
					&& get(i-2).pos.startsWith("R")) return true;
			if (v.wordform.equals(w.wordform)
					&& i > 2 
						&& (get(i-1).pos.startsWith("A") || get(i-1).pos.startsWith("P"))
						&& (get(i-2).pos.startsWith("A") || get(i-2).pos.startsWith("P"))
					&& get(i-3).pos.startsWith("R")) return true;
		}
		
		return false;
		
	}

}
