package bg.bas.dcl.entities;

import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.commons.lang3.StringEscapeUtils;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Element;

public class Word {
	
	public HashMap<String, String> remainingAttr = new HashMap<String, String>();
	
	public int wordID = -1;
	public String wordform = "";
	public String lemma = "";
	public String pos = "";
	public String wn = "";
	public String verbID = "";
	public String tokenTag = "";

	public String clauseID_old = "";
	public String clauseID = "";
	
	public int sentPositionIndex = -1;

	public String clauseConnectedID = "";
	public String clauseRelation = "";

	String clauseAlign = "";

	public String MWE = "";
	public String MWE_part = "";
	
	public boolean senEnd = false;
	public String sen = "";
	
	public Word reference = null;
	
	TextPosition textpos = new TextPosition(-1,-1);
	

	public HashMap<String,String> notes = new HashMap<String,String>();
	
	public Word(){
		
	}
	
	public Word(String l, String p){
		lemma = l;
		pos = p;
	}

	public Word(String l, String p, String w){
		lemma = l;
		pos = p;
		wn = w;
	}

	public Word(String xml){
//		readWordFromXML(xml);
	}
	
	public Word(Element word){
		
		if (word.hasAttribute("w")) wordform = word.getAttribute("w");
		if (word.hasAttribute("l")) lemma = word.getAttribute("l");
		if (word.hasAttribute("pos")) pos = word.getAttribute("pos");
		if (word.hasAttribute("wn")) wn = word.getAttribute("wn");
		if (word.hasAttribute("cl")) clauseID = word.getAttribute("cl");
		if (word.hasAttribute("cl_al")) clauseAlign = word.getAttribute("cl_al");
		if (word.hasAttribute("v")) verbID = word.getAttribute("v");
		if (word.hasAttribute("mwe")) {
			String[] data = word.getAttribute("mwe").split(":");
			if (data.length>0) MWE = data[0];
			if (data.length>1) MWE_part = data[1];
		}
		if (word.hasAttribute("cl2")) clauseConnectedID = word.getAttribute("cl2");
		if (word.hasAttribute("m")) clauseRelation = word.getAttribute("m");

		if (word.hasAttribute("p") && !word.hasAttribute("mwe")) {
			String[] data = word.getAttribute("p").split(":");
			if (data.length>0) MWE = data[0];
			if (data.length>1) MWE_part = data[1];
		}
		
		if (word.hasAttribute("sen")) sen = word.getAttribute("sen");
		if (word.hasAttribute("e") && word.getAttribute("e").equals("True")) {
			senEnd = true;
		}
		
		if (word.hasAttribute("u")) 
			remainingAttr.put("u", word.getAttribute("u"));
		if (word.hasAttribute("p")) 
			remainingAttr.put("p", word.getAttribute("p"));
		if (word.hasAttribute("s")) 
			remainingAttr.put("s", word.getAttribute("s"));
		if (word.hasAttribute("t")) 
			remainingAttr.put("t", word.getAttribute("t"));
		if (word.hasAttribute("e")) 
			remainingAttr.put("e", word.getAttribute("e"));

		
		
	}

	

	public String toXML (){

		String result = "<word ";

		result += "w=\"" +StringEscapeUtils.escapeXml(wordform)+ "\" ";
		result += "l=\"" +StringEscapeUtils.escapeXml(lemma)+ "\" ";
		result += "pos=\"" +StringEscapeUtils.escapeXml(pos)+ "\" ";
		
		if (wn.contains("null")) wn = "";
		result += "wn=\"" +StringEscapeUtils.escapeXml(wn)+ "\" ";
//		result += "mwe=\"" +StringEscapeUtils.escapeXml(MWE)+ "\" ";
		
		for (String key : remainingAttr.keySet()) {
			result += key + "=\"" +StringEscapeUtils.escapeXml(remainingAttr.get(key))+ "\" ";
		}
		
		if (!MWE.equals("")) result += "mwe=\"" 
				+StringEscapeUtils.escapeXml(MWE+ (MWE_part.equals("")? "" : (":"+ MWE_part)))+ "\" ";

		if (!clauseID.equals("")) result += "cl=\"" +StringEscapeUtils.escapeXml(clauseID)+ "\" ";
		if (!clauseConnectedID.equals("")) result += "cl2=\"" +StringEscapeUtils.escapeXml(clauseConnectedID)+ "\" ";
		if (!clauseRelation.equals("")) result += "m=\"" +StringEscapeUtils.escapeXml(clauseRelation)+ "\" ";
		if (!clauseAlign.equals("")) result += "cl_al=\"" +StringEscapeUtils.escapeXml(clauseAlign)+ "\" ";
		if (!verbID.equals("")) result += "v=\"" +StringEscapeUtils.escapeXml(verbID)+ "\" ";
		if (!clauseID_old.equals("")) result += "cl_old=\"" +StringEscapeUtils.escapeXml(clauseID_old)+ "\" ";

		
		result += "/>";
		return result;
	}


	public void readFromVertical(String l){
		String[] data = l.split("\t");
		
		if (data.length>0) wordform = data[0];
		if (data.length>1) tokenTag = data[1];
		if (data.length>2) lemma = data[2];
		if (data.length>3) pos = data[3];
//		if (data.length>4) wordform = data[0];
		
	}
	
}
