package bg.bas.dcl.general;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.Scanner;

import org.htmlparser.Node;
import org.htmlparser.NodeFilter;
import org.htmlparser.Parser;
import org.htmlparser.filters.NodeClassFilter;
import org.htmlparser.tags.Div;
import org.htmlparser.tags.LinkTag;
import org.htmlparser.util.NodeIterator;
import org.htmlparser.util.NodeList;
import org.htmlparser.util.ParserException;

import bg.bas.dcl.general.FileHandler;


/**
 * Extension of htmlparser
 * @author ivelina
 *
 */
public class HTMLParser extends Parser {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;


	public HTMLParser(){}
	
	public HTMLParser(String filename) throws ParserException{
		
		File f = new File(filename);
		try {
			setInputHTML(FileHandler.getContents(f));
			
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public HTMLParser(String url, boolean isUrl) throws ParserException{
		
		super(url);
		
	}

	
	public HTMLParser(Node n) throws ParserException{
		
		setInputHTML(n.getText());
	}

	
	/**
	 * 
	 * @param filter
	 * @param single
	 * @return
	 * @throws ParserException
	 */

	public NodeList extractAllNodesThatMatch (NodeFilter filter, boolean single)
		    throws
		        ParserException
		{
		    NodeIterator e;
		    NodeList ret;
		    int time = 0;
		    ret = new NodeList ();
		    e = elements ();
		    
		    while (e.hasMoreNodes ()){
		    	Node n = e.nextNode ();
		        n.collectInto (ret, filter);
		        if (single && time > 1){
		        	return (ret);
		        } else time++;
		    }
		    return (ret);
		}

	/**
	 * @param args
	 */
	public ArrayList<String> harvestLinks () {
		ArrayList<String> links = new ArrayList<String>();

		try {
			
			
			NodeClassFilter ncf = new NodeClassFilter(LinkTag.class);
			
			NodeList tagNodeList = extractAllNodesThatMatch(ncf,true);
	        for (int j = 0; j < tagNodeList.size(); j++) {
	            LinkTag loopLink = (LinkTag) tagNodeList.elementAt(j);
	            String loopLinkStr = loopLink.getLink();
	            	            
	            if (!links.contains(loopLinkStr)) {
	            	links.add(loopLinkStr);
	            }
	        }
			
		} catch (ParserException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return links;
	}



	public static String detectEncoding(String url){
		String[] encodings = {"utf-8","windows-1251","ISO-8859-1"};
		try{
			URLConnection connection =  new URL(url).openConnection();
			InputStream resultingInputStream = connection.getInputStream();   

			
				Scanner scanner = new Scanner(resultingInputStream);
				while (scanner.hasNextLine()) {
					String line = scanner.nextLine();
					
					for (String enc : encodings){
						if (line.contains("charset=")&&line.contains(enc)) {
							return enc;
						}
					}
				}
	   	    	scanner.close();
		       	    	 
			} catch (Exception e){
				
			}

		return null;
	}
	

}
