package bg.bas.dcl.general;

import java.util.ArrayList;
import java.util.HashMap;

public class Transliterator {
	
	HashMap<String,String[]> twolettermap = new HashMap<String,String[]>();
	HashMap<String,String[]> map = new HashMap<String,String[]>();

	
	public Transliterator(){
		
		setLAT2CYRMaps();
		
	}
	
	public Transliterator(String targetlang){
		if (targetlang.toLowerCase().equals("bg")) setLAT2CYRMaps();
		if (targetlang.toLowerCase().equals("cyr")) setLAT2CYRMaps();
		
		if (targetlang.toLowerCase().equals("en")) setCYR2LATMaps();
		if (targetlang.toLowerCase().equals("lat")) setCYR2LATMaps();
		
	}

	public void setLAT2CYRMaps(){
		twolettermap.put("rz", new String[]{"ж","р"});
		twolettermap.put("Rz", new String[]{"Ж","Р"});
		twolettermap.put("ch", new String[]{"х","ч","к"});
		twolettermap.put("Ch", new String[]{"Х","Ч","К"});
		twolettermap.put("cz", new String[]{"ч"});
		twolettermap.put("Cz", new String[]{"Ч"});
	
		twolettermap.put("ja", new String[]{"я"});
		twolettermap.put("Ja", new String[]{"Я"});
		
		twolettermap.put("ou", new String[]{"у"});
		
		twolettermap.put("ll", new String[]{"л"});
		twolettermap.put("ss", new String[]{"с"});
		twolettermap.put("zz", new String[]{"з"});
		twolettermap.put("tt", new String[]{"т"});
		twolettermap.put("ff", new String[]{"ф"});
		twolettermap.put("rr", new String[]{"р"});
		twolettermap.put("bb", new String[]{"б"});
		twolettermap.put("dd", new String[]{"д"});
		twolettermap.put("cc", new String[]{"к"});
		twolettermap.put("pp", new String[]{"п"});
	
		map.put(" ", new String[]{" "});
		map.put("-", new String[]{"-"});
		map.put("a", new String[]{"а"});  //{"а","я"});
		map.put("b", new String[]{"б"});
		map.put("c", new String[]{"к","ц","с"});
		map.put("d", new String[]{"д"});
		map.put("e", new String[]{"е"}); //{"е","и"});
		map.put("f", new String[]{"ф"});
		map.put("g", new String[]{"г","дж","ж"});
		map.put("h", new String[]{"х"});
		map.put("i", new String[]{"и"});
		map.put("j", new String[]{"й","дж","ж"});
		map.put("k", new String[]{"к"});
		map.put("l", new String[]{"л"});
		map.put("m", new String[]{"м"});
		map.put("n", new String[]{"н"});
		map.put("o", new String[]{"о"});
		map.put("p", new String[]{"п"});
		map.put("q", new String[]{"к"});
		map.put("r", new String[]{"р"});
		map.put("s", new String[]{"с"}); //{"с","ш"});
		map.put("t", new String[]{"т"});
		map.put("u", new String[]{"у"}); // {"у","ю"});
		map.put("v", new String[]{"в"});
		map.put("w", new String[]{"в","у"});
		map.put("x", new String[]{"кс"});
		map.put("y", new String[]{"и","ъ","й", "ь"});
		map.put("z", new String[]{"з"});
		map.put("ł", new String[]{"л"});
		map.put("ż", new String[]{"ж"}); //{"ж","з"});
		map.put("ń", new String[]{"н"});
		map.put("ó", new String[]{"о"});
		map.put("ę", new String[]{"е"});
		map.put("ö", new String[]{"о"});
		map.put("ś", new String[]{"ш"}); // {"ш","с"});
		map.put("ć", new String[]{"ч","ц"}); 
		map.put("ź", new String[]{"ж","з"});
		map.put("ą", new String[]{"а"});
		map.put("í", new String[]{"и"});
		map.put("ø", new String[]{"о"});
		map.put("à", new String[]{"а"});
		map.put("ò", new String[]{"о"});
		map.put("è", new String[]{"е"});		//  
		map.put("é", new String[]{"е"});		//  
		
		

		map.put("A", new String[]{"А","Я"});
		map.put("B", new String[]{"Б"});
		map.put("C", new String[]{"К","Ц","С"});
		map.put("D", new String[]{"Д"});
		map.put("E", new String[]{"Е","И"});
		map.put("F", new String[]{"Ф"});
		map.put("G", new String[]{"Г","Дж","Ж"});
		map.put("H", new String[]{"Х"});
		map.put("I", new String[]{"И","Ай"});
		map.put("J", new String[]{"Й","Дж","Ж"});
		map.put("K", new String[]{"К"});
		map.put("L", new String[]{"Л"});
		map.put("M", new String[]{"М"});
		map.put("N", new String[]{"Н"});
		map.put("O", new String[]{"О","Оу"});
		map.put("P", new String[]{"П"});
		map.put("Q", new String[]{"К"});
		map.put("R", new String[]{"Р"});
		map.put("S", new String[]{"С","Ш"});
		map.put("T", new String[]{"Т"});
		map.put("U", new String[]{"У","Ю"});
		map.put("V", new String[]{"В"});
		map.put("W", new String[]{"В","У"});
		map.put("X", new String[]{"Кс"});
		map.put("Y", new String[]{"И","Ъ","Й", "Ь"});
		map.put("Z", new String[]{"З"});
		map.put("Ł", new String[]{"Л"});
		map.put("Ż", new String[]{"Ж","З"});
		map.put("Ń", new String[]{"Н"});
		map.put("Ó", new String[]{"О"});
		map.put("Ę", new String[]{"Е"});
		map.put("Ć", new String[]{"Ч","Ц"});
		map.put("Ź", new String[]{"Ж","З"});
		map.put("Ś", new String[]{"С","Ш"});
		map.put("Ą", new String[]{"А"});
		map.put("È", new String[]{"Е"});
		map.put("É", new String[]{"Е"});		//  

	}
	
	public void setCYR2LATMaps(){
	
		map.put("а", new String[]{"a"});
		map.put("б", new String[]{"b"});
		map.put("в", new String[]{"v"});  //{"а","я"});
		map.put("г", new String[]{"g"});
		map.put("д", new String[]{"d"});
		map.put("е", new String[]{"e"});
		map.put("ж", new String[]{"zh"}); //{"е","и"});
		map.put("з", new String[]{"z"});
		map.put("и", new String[]{"i"});
		map.put("й", new String[]{"y"});
		map.put("к", new String[]{"k"});
		map.put("л", new String[]{"l"});
		map.put("м", new String[]{"m"});
		map.put("н", new String[]{"n"});
		map.put("о", new String[]{"o"});
		map.put("п", new String[]{"p"});
		map.put("р", new String[]{"r"});
		map.put("с", new String[]{"s"});
		map.put("т", new String[]{"t"});
		map.put("у", new String[]{"u"});
		map.put("ф", new String[]{"f"}); //{"с","ш"});
		map.put("х", new String[]{"h"});
		map.put("ц", new String[]{"ts"}); // {"у","ю"});
		map.put("ч", new String[]{"ch"});
		map.put("ш", new String[]{"sh"});
		map.put("щ", new String[]{"sht"});
		map.put("ъ", new String[]{"a"});
		map.put("ь", new String[]{"a"});
		map.put("ю", new String[]{"yu"});
		map.put("я", new String[]{"ya"}); //{"ж","з"});
		

		map.put("А", new String[]{"A"});
		map.put("Б", new String[]{"B"});
		map.put("В", new String[]{"V"});
		map.put("Г", new String[]{"G"});
		map.put("Д", new String[]{"D"});
		map.put("Е", new String[]{"E"});
		map.put("Ж", new String[]{"Zh"});
		map.put("З", new String[]{"Z"});
		map.put("И", new String[]{"I"});
		map.put("Й", new String[]{"Y"});
		map.put("К", new String[]{"K"});
		map.put("Л", new String[]{"L"});
		map.put("М", new String[]{"M"});
		map.put("Н", new String[]{"N"});
		map.put("О", new String[]{"O"});
		map.put("П", new String[]{"P"});
		map.put("Р", new String[]{"R"});
		map.put("С", new String[]{"S"});
		map.put("Т", new String[]{"T"});
		map.put("У", new String[]{"U"});
		map.put("Ф", new String[]{"F"});
		map.put("Х", new String[]{"H"});
		map.put("Ц", new String[]{"Ts"});
		map.put("Ч", new String[]{"Ch"});
		map.put("Ш", new String[]{"Sh"});
		map.put("Щ", new String[]{"Sht"});
		map.put("Ъ", new String[]{"A"});
		map.put("Ь", new String[]{"A"});
		map.put("Ю", new String[]{"Yu"});
		map.put("Я", new String[]{"Ya"});

	}

	public String getTransliteration(String word){
		
		 ArrayList<String> tr = transliterate(word);
		return tr.get(tr.size()-1);
		
	}

	
	public ArrayList<String> transliterate(String lat){
		
		ArrayList<String> cyr = new ArrayList<String>();
		ArrayList<Integer> cyr_pos = new ArrayList<Integer>();
		
		cyr.add(lat);
		cyr_pos.add(0);
		
	
		boolean ready = false;

		while (!ready){
			
			ArrayList<String> temp = new ArrayList<String>();
			ArrayList<Integer> temp_pos = new ArrayList<Integer>();

			ready = true;
			
			for (int i = 0; i<cyr.size(); i++) {
				
				String word = cyr.get(i);
				int pos = cyr_pos.get(i);
				
				String rep = "";
				if (pos > word.length()-1) continue;
				
					if (pos+1<word.length()) rep = word.substring(pos, pos+2);
					if (twolettermap.containsKey(rep)) {
						String[] replacements = twolettermap.get(rep);
						for (String r : replacements) {
							temp.add(word.replace(rep, r));
							temp_pos.add(pos+r.length());
							if (pos+r.length()<word.length()) ready = false;
						}
					} else {
						if(pos<word.length()) rep = word.substring(pos, pos+1);
						if (map.containsKey(rep)) {
							String[] replacements = map.get(rep);
							for (String r : replacements) {
								temp.add(word.replace(rep, r));
								temp_pos.add(pos+r.length());
								if (pos+r.length()<word.length()) ready = false;
							}
						} else {
							temp.add(word);
							temp_pos.add(pos+1);
							if (pos+1<word.length()) ready = false;
						}
					}
					
			}

			cyr = temp;
			cyr_pos = temp_pos;
		}
		
		return cyr;
		
	}




}
