package bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser;

import java.util.ArrayList;

import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.TextPosition;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.entities.Word;

public class VerbFormModel extends ArrayList<VerbComponent>{

	public String tense = "";
	public int len = 0;
	
	public void readVerbFormModelFromString(String l, int n){
		
		String[] data = l.split("\t");
		
		// data[0] is the tense;
		// data[1] is the struct
		// data[2] agreement requirements, notes, etc.
		
		if (data.length<2) return;
		
		tense = data[0];
		
		String[] components = data[1].split(" ");
		
		for (String d : components) {
			
			if (d.trim().equals("")) continue;
			
			VerbComponent vc = new VerbComponent();
			vc.readComponentTypeFromString(d, n);
			
			if (!vc.optional) len ++;
			
			add(vc);
			
		}
		
	}
	
	public VerbForm findMatch(Sentence sent, int start) {
		
		VerbForm res = new VerbForm();
		
		if (start>0 && sent.get(start-1).lemma.equals("се")) {
			res.add(new TextPosition(0,start-1));
		}

		if (start+len > sent.size()) return null;

		
		int optionalCtr = 0;
		int j = 0;
			
		for (int i = start; i<sent.size(); i++) {

			
			if (j>=this.size()) {
				if (sent.get(i).lemma.equals("се")) 
					res.add(new TextPosition(0,i));

				return res;
			}
			
			Word t = sent.get(i);
			
//			if (i>0 && Character.isUpperCase(t.token.charAt(0))) return null;
			
			VerbComponent vc = get(j);


//			System.out.println("COMPARE "
//					+ t.lemma +"\t" + t.posTag
//					+"\t"
//					+ vc.lemma +"\t" + vc.pos);

			if (!vc.optional) {
				
				if (!vc.isMatch(t)) return null;
/**
				System.out.println("MODEL "
						+"\t"+ vc.lemma
						+"\t" + vc.pos
						+"\t" + vc.optional
						+"\t" + t.lemma
						+"\t" + t.pos);
*/				
				if (t.pos.startsWith("V")
							&& !vc.isAux()) {
					res.mainword = t;
					
				}

				res.add(new TextPosition(0,i));
				
				optionalCtr = 0;
				j++;
				
			} else {
				
				if (!vc.isMatch(t)) {
					
					j++;
					i--;
					/**
					System.out.println("OP DOES NOT MATCH "
							+ t.lemma +"\t" + t.posTag
							+"\t"
							+ vc.lemma +"\t" + vc.pos);
					 */
					continue;
				}
				
				optionalCtr ++;
				if (t.lemma.equals("се")) res.add(new TextPosition(0,i));
				
				if (optionalCtr>vc.optionalNum) return null;
				
				
				
			}
			
			
		}
		
		if (res.size()==0) return null;
			
		int i = res.get(res.size()-1).sentpos;
		if (i<sent.size()-1 && sent.get(i+1).lemma.equals("се")) 
			res.add(new TextPosition(0,i+1));
		
		System.out.println(res.mainword.lemma);
		return res;
	}
	
	public int getFormModelLen(){
		int len = 0;
		for (VerbComponent vc : this){
			if (!vc.optional) len++;
		}
		return len;
	}
	
	public String getModel(){
		
		String res = "";
		
		for (VerbComponent vc : this){
			
			if (vc.optional) res += vc.optionalNum + "O ";
			else res += vc.lemma +":" + vc.pos + " ";
		}
		
		return res;
	}
	
}
