package bg.bas.dcl.multilingual.ClauseSplitting;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.Word;
import bg.bas.dcl.general.FileHandler;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.ClauseVerb;

public class ClauseSplitterEvaluator {
	
	ArrayList<Integer> ctr = new ArrayList<Integer>();
	ArrayList<Integer> total = new ArrayList<Integer>();
	
	public int CORRECTBORDER = 0, CORRECTOPENING = 1, CORRECTCLOSING = 2, CORRECTSENTENCE = 3,
			BORDER = 4, OPENING = 5, CLOSING = 6, SENTENCE = 7,
			WRONGBORDER = 8, WRONGOPENING = 9, WRONGCLOSING = 10, WRONGSENTENCE = 11,
			CORRECTSTARTOPENING = 12, STARTOPENING = 13, CORRECTENDCLOSING = 14, ENDCLOSING = 15,
			CORRECTCLAUSE = 16, CLAUSE = 17, 
			REALBORDER = 18, REALOPENING = 19, REALCLOSING = 20, REALWORDS = 21
			;
	
	ArrayList<Integer> finalresult = new ArrayList<Integer>();
	
	FileHandler fh = new FileHandler();
	
	public void evaluateClauseSplitting(
			String inDir){

		try{
			List<File> list = fh.getFileListing(new File(inDir));
			
			for (File f : list){
				
				if (!f.isFile()) continue;
				
				
				
			}
			
		} catch(Exception e){
			e.printStackTrace();
		}
		

	}

	
	public ArrayList<Integer> evaluateClauseSplittingSentence(
			Sentence sent, 
			ArrayList<ClauseBorder> allboundaries,
			ArrayList<ClauseVerb> verbs){
		
		
		ArrayList<Integer> result = new ArrayList<Integer>();
		
		for (int i=0; i<22; i++) result.add(0);
		
		ArrayList<String> takenIDs = new ArrayList<String>();
		
		ArrayList<Boolean> resultboundaries = new ArrayList<Boolean>();
		
		
		for (int i = 0; i<allboundaries.size(); i++){
			
			ClauseBorder border = allboundaries.get(i);
			
			if (border.type.contains("CO")) {
				Word t = sent.get(border.position);
				
				result.set(BORDER, result.get(BORDER)+1);
				result.set(OPENING, result.get(OPENING)+1);
				
				if (border.position == 0
						|| (!sent.get(border.position-1).remainingAttr
								.get("old_clauseID").equals(
										t.remainingAttr.get("old_clauseID"))
								&& !takenIDs.contains(t.remainingAttr.get("old_clauseID")))) {
					result.set(CORRECTBORDER, result.get(CORRECTBORDER)+1);
					result.set(CORRECTOPENING, result.get(CORRECTOPENING)+1);
					
					if (border.position == 0) {
						result.set(CORRECTSTARTOPENING, result.get(CORRECTSTARTOPENING)+1);
						result.set(STARTOPENING, result.get(STARTOPENING)+1);
					}
					
					resultboundaries.add(true);
				} else {
					
					result.set(WRONGBORDER, result.get(WRONGBORDER)+1);
					result.set(WRONGOPENING, result.get(WRONGOPENING)+1);
					resultboundaries.add(false);
				}
				
				takenIDs.add(t.remainingAttr.get("old_clauseID"));
				continue;
			}
			
			if (border.type.contains("CC")) {
				Word t = sent.get(border.position);
				
				result.set(BORDER, result.get(BORDER)+1);
				result.set(CLOSING, result.get(CLOSING)+1);
				
				result.set(CLAUSE, result.get(CLAUSE)+1);

				if (border.position == sent.size()-1
						|| (!sent.get(border.position+1).remainingAttr.get("old_clauseID")
								.equals(t.remainingAttr.get("old_clauseID"))
								&& !clauseIDAppearsAgain(t.remainingAttr.get("old_clauseID"), sent, border.position+1))) {
					result.set(CORRECTBORDER, result.get(CORRECTBORDER)+1);
					result.set(CORRECTCLOSING, result.get(CORRECTCLOSING)+1);
					
					if (border.position == sent.size()-1) {
						result.set(CORRECTENDCLOSING, result.get(CORRECTENDCLOSING)+1);
						result.set(ENDCLOSING, result.get(ENDCLOSING)+1);
					}
					
					
					int co = 0;
					for (int j=i-1; j>-1; j--){
						
						if (co==0 && allboundaries.get(j).type.contains("CO")) {
							
							if (resultboundaries.get(j)) {
								result.set(CORRECTCLAUSE, result.get(CORRECTCLAUSE)+1);
							}
							
							break;
						}
						
						if (allboundaries.get(j).type.contains("CO")) co--;
						else co++;
					}
					resultboundaries.add(true);

				} else {
					
					result.set(WRONGBORDER, result.get(WRONGBORDER)+1);
					result.set(WRONGCLOSING, result.get(WRONGCLOSING)+1);
					resultboundaries.add(false);
				}
				
				takenIDs.add(t.remainingAttr.get("old_clauseID"));
				continue;
			}
			
			result.set(BORDER, result.get(BORDER)+1);
			result.set(WRONGBORDER, result.get(WRONGBORDER)+1);
			result.set(WRONGCLOSING, result.get(WRONGCLOSING)+1);
			resultboundaries.add(false);

		}
		
		ArrayList<String> processedIDs = new ArrayList<String>();
		for (int i = 0; i<sent.size(); i++) {
			Word t = sent.get(i);
			
			if (i==0 
					|| (!t.remainingAttr.get("old_clauseID")
							.equals(sent.get(i-1).remainingAttr.get("old_clauseID"))
							&& !processedIDs.contains(t.remainingAttr.get("old_clauseID")))) {
				result.set(REALBORDER, result.get(REALBORDER)+1);
				result.set(REALOPENING, result.get(REALOPENING)+1);

				

				
			}
			
			if (i==sent.size()-1 
					|| (!t.remainingAttr.get("old_clauseID").equals(sent.get(i+1).remainingAttr.get("old_clauseID"))
							&& !clauseIDAppearsAgain(t.remainingAttr.get("old_clauseID"), sent, i+1))) {
				result.set(REALBORDER, result.get(REALBORDER)+1);
				result.set(REALCLOSING, result.get(REALCLOSING)+1);

				

				
			}
			
			processedIDs.add(t.remainingAttr.get("old_clauseID"));

		}
		
		result.set(SENTENCE, result.get(SENTENCE)+1);
		if (result.get(BORDER) == result.get(CORRECTBORDER)
				&& result.get(BORDER) == result.get(REALBORDER)
				) {
			result.set(CORRECTSENTENCE, result.get(CORRECTSENTENCE)+1);
		}
		
		return result;
	}

	
	public ArrayList<Integer> evaluateClauseSplittingSentence(
			Sentence sent,
			ArrayList<ClauseVerb> verbs){

		System.out.println("EVALUATE");
		
		for (Word t:sent) System.out.print(t.wordform+"/"+t.remainingAttr.get("old_clauseID")+" ");
		System.out.println();		
		System.out.println();
		
		for (Word t:sent) System.out.print(t.wordform+"/"+t.clauseID+" ");
		System.out.println();
		
		ArrayList<Integer> result = new ArrayList<Integer>();
		
		for (int i=0; i<22; i++) result.add(0);
		
		HashMap<String,String> clauseIDCorrespondence = new HashMap<String,String>();
		
		ArrayList<Boolean> resultboundaries = new ArrayList<Boolean>();
		
		
		for (int i = 0; i<sent.size(); i++){
			
			Word t = sent.get(i);
			
			if (i==0 
					|| (!sent.get(i-1).clauseID.equals(t.clauseID)
							&& !clauseIDCorrespondence.keySet().contains(t.clauseID))) {

				result.set(BORDER, result.get(BORDER)+1);
				result.set(OPENING, result.get(OPENING)+1);
	

				if (i == 0
						|| (!sent.get(i-1).remainingAttr.get("old_clauseID").equals(t.remainingAttr.get("old_clauseID"))
								&& !clauseOldIDAppears(t.remainingAttr.get("old_clauseID"), sent, 0, i-1))) {
					result.set(CORRECTBORDER, result.get(CORRECTBORDER)+1);
					result.set(CORRECTOPENING, result.get(CORRECTOPENING)+1);
					
//					result.set(REALBORDER, result.get(REALBORDER)+1);
//					result.set(REALOPENING, result.get(REALOPENING)+1);

					if (i == 0) {
						result.set(CORRECTSTARTOPENING, result.get(CORRECTSTARTOPENING)+1);
						result.set(STARTOPENING, result.get(STARTOPENING)+1);
					}
					
					resultboundaries.add(true);
				} else {
					
					result.set(WRONGBORDER, result.get(WRONGBORDER)+1);
					result.set(WRONGOPENING, result.get(WRONGOPENING)+1);
					
					resultboundaries.add(false);
				}
				
				clauseIDCorrespondence.put(t.clauseID, t.remainingAttr.get("old_clauseID"));

//				continue;
			}
			
			if (i==sent.size()-1 
					|| (!sent.get(i+1).clauseID.equals(t.clauseID)
							&& !clauseIDAppearsAgain(t.clauseID, sent, i+1))) {
				
				result.set(BORDER, result.get(BORDER)+1);
				result.set(CLOSING, result.get(CLOSING)+1);
				
				result.set(CLAUSE, result.get(CLAUSE)+1);

				if (i == sent.size()-1
						|| (!sent.get(i+1).remainingAttr.get("old_clauseID").equals(t.remainingAttr.get("old_clauseID"))
								&& !clauseOldIDAppearsAgain(t.remainingAttr.get("old_clauseID"), sent, i+1))) {
					result.set(CORRECTBORDER, result.get(CORRECTBORDER)+1);
					result.set(CORRECTCLOSING, result.get(CORRECTCLOSING)+1);
					
//					result.set(REALBORDER, result.get(REALBORDER)+1);
//					result.set(REALCLOSING, result.get(REALCLOSING)+1);

					if (i == sent.size()-1) {
						result.set(CORRECTENDCLOSING, result.get(CORRECTENDCLOSING)+1);
						result.set(ENDCLOSING, result.get(ENDCLOSING)+1);
					}
					

					if (resultboundaries.get(resultboundaries.size()-1)) {
						result.set(CORRECTCLAUSE, result.get(CORRECTCLAUSE)+1);

					} 


				} else {
					
					result.set(WRONGBORDER, result.get(WRONGBORDER)+1);
					result.set(WRONGCLOSING, result.get(WRONGCLOSING)+1);
					
				}
				
				resultboundaries.remove(resultboundaries.size()-1);

				
//				continue;
			}			

		}
		
		ArrayList<String> processed = new ArrayList<String>();
		for (int i = 0; i<sent.size(); i++) {
			
			Word t = sent.get(i);
	
			if (i==0 ||
					(!t.remainingAttr.get("old_clauseID")
							.equals(sent.get(i-1).remainingAttr.get("old_clauseID"))
					&& !clauseOldIDAppears(t.remainingAttr.get("old_clauseID"), sent, 0, i-1))){

				result.set(REALBORDER, result.get(REALBORDER)+1);
				result.set(REALOPENING, result.get(REALOPENING)+1);

//				continue;
			}

			if (i==sent.size()-1 
					||( !t.remainingAttr.get("old_clauseID")
							.equals(sent.get(i+1).remainingAttr.get("old_clauseID"))
					&& !clauseOldIDAppearsAgain(t.remainingAttr.get("old_clauseID"), sent, i+1))){

				result.set(REALBORDER, result.get(REALBORDER)+1);
				result.set(REALCLOSING, result.get(REALCLOSING)+1);

			}

		}
				
		result.set(SENTENCE, result.get(SENTENCE)+1);
		if (result.get(BORDER) == result.get(CORRECTBORDER)
				&& result.get(BORDER) == result.get(REALBORDER)
				) {
			result.set(CORRECTSENTENCE, result.get(CORRECTSENTENCE)+1);
		}
		
		return result;
	}

	public boolean clauseOldIDAppears(String clauseID, 
			Sentence sent, int pos1, int pos2){

		for (int i=pos1; i<Math.min(pos2,sent.size()); i++){
			if (sent.get(i).remainingAttr.get("old_clauseID").equals(clauseID)) return true;
		}
		
		return false;
	
	}

	
	
	public boolean clauseOldIDAppearsAgain(String clauseID, 
			Sentence sent, int pos){

		for (int i=pos; i<sent.size(); i++){
			if (sent.get(i).remainingAttr.get("old_clauseID").equals(clauseID)) return true;
		}
		
		return false;
	
	}
	
	
	
	public boolean clauseIDAppearsAgain(String clauseID, 
					Sentence sent, int pos){
		
		for (int i=pos; i<sent.size(); i++){
			if (sent.get(i).clauseID.equals(clauseID)) return true;
		}
		
		return false;
		
	}
	
	
	/**
	 	public void evaluateRuleBasedClauseSplitter(){
		
		int correctBeginnings = 0;
		int correctBorders = 0;
		int allBorders = 0;
		int foundBorders = 0;

		int foundBeginnings = 0;

		int misplacedEnds = 0;
		int falseEnds = 0;
		int allEnds = 0;

		int wrongFull = 0;
		int allFull = 0;
		int foundFull = 0;

		
		FileHandler fh = new FileHandler();
		try{
			
			
			
			List<File> list = fh.getFileListing(new File(outputDir));
			System.out.println("Starting... " + inputDir + "\t" + list.size());
			
			for (File f : list) {
				
				if (!f.isFile()) continue;
				if (f.getName().endsWith("~")) continue;

				if (!f.getName().endsWith(".txt")
						&& !f.getName().endsWith(".xml")) continue;
				
					
				System.out.println(f.getAbsolutePath());
				DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
				DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
				Document doc = dBuilder.parse(f);
				 
				//optional, but recommended
				//read this - http://stackoverflow.com/questions/13786607/normalization-in-dom-parsing-with-java-how-does-it-work
				doc.getDocumentElement().normalize();
					 				
				NodeList sentList = doc.getElementsByTagName("S");

							
				for (int j = 0; j < sentList.getLength(); j++) {
					
					Node sentNode = sentList.item(j);
					
					if (sentNode.getNodeType() != Node.ELEMENT_NODE) continue;
					
					Element sentElement = (Element) sentNode;

					Sentence sent = new Sentence();
					
					NodeList wordList = sentElement.getElementsByTagName("word");
									
					for (int i = 0; i < wordList.getLength(); i++) {
						 
						Node wordNode = wordList.item(i);
						
						if (wordNode.getNodeType() != Node.ELEMENT_NODE) continue;
						
						Element element = (Element) wordNode;
						
						Word w = new Word();
						w.wordform = StringEscapeUtils.unescapeXml(element.getAttribute("w"));	
						
						if (w.wordform.equals("====")) continue;
						
						w.lemma = StringEscapeUtils.unescapeXml(element.getAttribute("l"));
						w.pos = StringEscapeUtils.unescapeXml(element.getAttribute("pos"));
		
						if (element.hasAttribute("cl_old")) 
							w.clauseID_old = StringEscapeUtils.unescapeXml(element.getAttribute("cl_old"));
						if (element.hasAttribute("cl")) 
							w.clauseID = StringEscapeUtils.unescapeXml(element.getAttribute("cl"));
						if (element.hasAttribute("m")) 
							w.clauseRelation= StringEscapeUtils.unescapeXml(element.getAttribute("m"));
						if (element.hasAttribute("MWE")) 
							w.MWE = StringEscapeUtils.unescapeXml(element.getAttribute("p"));
						
		
						sent.add(w);
						sent.sentenceText += w.wordform + " ";					
						
					}
					
					ArrayList<String> clauseIDs = new ArrayList<String>();
					ArrayList<String> newClauseIDs = new ArrayList<String>();
					ArrayList<String> fullClauseIDs = new ArrayList<String>();
					
					ArrayList<String> skippedClauseIDs = new ArrayList<String>();
					
					for (int i = 0; i < sent.size(); i++) {
						Word w = sent.get(i);
						if (i == 0) {
							correctBeginnings += 1;
							foundBeginnings += 1;
							
							fullClauseIDs.add(w.clauseID);
							
						} else {
							Word prevw = sent.get(i-1);
							if (!w.clauseID_old.equals(prevw.clauseID_old)){
					
								System.out.println("CHECK\t" + prevw.clauseID_old + "\t" 
										+ w.clauseID_old + "\t"
										+ prevw.clauseID + "\t" 
										+ w.clauseID) ;
								allBorders += 1;
								if (!w.clauseID.equals(prevw.clauseID)){ 
										
										correctBorders += 1;
										foundBorders += 1;
										
								}

								
								if (!w.clauseID.equals(prevw.clauseID)
									&& !clauseIDs.contains(w.clauseID_old)){ 
									
									correctBeginnings += 1;
									foundBeginnings += 1;
								
								}
								
								
								if (w.clauseID.equals(prevw.clauseID)){
									
									wrongFull += 1;

									if (clauseIDs.contains(w.clauseID_old)){ 
										misplacedEnds += 1;

									} else {
										skippedClauseIDs.add(w.clauseID_old);
									}
									
								
								}

								allEnds += 1;
								
								
							} else {
								
								if (!w.clauseID.equals(prevw.clauseID)){ 
									
									wrongFull += 1;
									falseEnds += 1;
								
									foundBorders += 1;
//									foundBeginnings += 1;
								}
								
								if (!w.clauseID.equals(prevw.clauseID)
										&& !newClauseIDs.contains(w.clauseID)){ 
										
									foundBeginnings += 1;
									
									}


							}
						
						}
						
						if (!clauseIDs.contains(w.clauseID_old)) clauseIDs.add(w.clauseID_old);
						if (!newClauseIDs.contains(w.clauseID)) newClauseIDs.add(w.clauseID);
						
						if (skippedClauseIDs.contains(w.clauseID_old)) skippedClauseIDs.remove(w.clauseID_old);
					}

					allFull += clauseIDs.size();
					foundFull += newClauseIDs.size();
				}
		
				
				
			}
			
			System.out.println("Correct begin: " + correctBeginnings);
			System.out.println("All begin: " + allFull);
			System.out.println("Correct borders: " + correctBorders);
			
			System.out.println("Misplaced ends: " + misplacedEnds );
			System.out.println("False ends: " + ( misplacedEnds - falseEnds));
			System.out.println("All ends: " + allEnds);

			System.out.println("Wrong full: " + wrongFull);
			System.out.println("All clauses: " + allFull);


			System.out.println("In-sentence borders\n" + "\tPrecision\tRecall\tF1 score");
			System.out.println("Borders" + "\t"
						+ (correctBorders * 100.0)/foundBorders + "\t"
						+ (correctBorders * 100.0)/allBorders + "\t"
						+ (
								2*((correctBorders * 100.0)/foundBorders * (correctBorders * 100.0)/allBorders)
								/ ((correctBorders * 100.0)/foundBorders + (correctBorders * 100.0)/allBorders)
								));
			System.out.println("COs\n" + "\tPrecision\tRecall\tF1 score");
			System.out.println("COs" + "\t"
						+ (correctBeginnings * 100.0)/foundBeginnings + "\t"
						+ (correctBeginnings * 100.0)/allFull + "\t"
						+ (
								2*((correctBeginnings * 100.0)/foundBeginnings * (correctBeginnings * 100.0)/allFull)
								/ ((correctBeginnings * 100.0)/foundBeginnings + (correctBeginnings * 100.0)/allFull)
								));
			
			System.out.println("Full clauses\n" + "\tPrecision\tRecall\tF1 score");
			System.out.println("Clauses" + "\t"
						+ ((allFull-wrongFull) * 100.0)/foundFull + "\t"
						+ ((allFull-wrongFull) * 100.0)/allFull + "\t"
						+ (
								2*(((allFull-wrongFull) * 100.0)/foundFull * ((allFull-wrongFull) * 100.0)/allFull)
								/ (((allFull-wrongFull) * 100.0)/foundFull + ((allFull-wrongFull) * 100.0)/allFull)
								));
//			System.out.println("CO" + "\t" + + "\t"+ (correctBeginnings * 100.0)/allFull);
//			System.out.println("Full" + "\t" + + "\t" + ((allFull-wrongFull) * 100.0)/allFull);

			
			
		} catch(Exception e){
			e.printStackTrace();
		}

		
	}
	 * 
	 * 
	 */

}
