package bg.bas.dcl.multilingual.ClauseSplitting.rules;

import java.util.ArrayList;
import java.util.HashMap;

import bg.bas.dcl.entities.Conjunction;
import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.Word;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.ClauseVerb;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseBorder;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseSplittingComplexObject;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseStack;

public class ClosingCommaClauseSplittingRule implements ClauseSplittingRule {
	
	public boolean isEndingRule = true;
	
	public boolean chooseFirstComma = true;
	public ArrayList<String> commas = new ArrayList<String>();
	
	
	public ClosingCommaClauseSplittingRule(boolean chooseFirstComma){
		
		this.chooseFirstComma = chooseFirstComma;
		
		commas.add(";");
		commas.add(",");
		commas.add("-");
		// might as well include other punct marks
	
	
	}

	
	public ClauseSplittingComplexObject findClauseBorders(
			Sentence sentence,
			ArrayList<ClauseVerb> verbs, 
			int spos, int epos,
			ClauseStack stack
			){
		
		ClauseSplittingComplexObject obj = new ClauseSplittingComplexObject();
		obj.cls = stack;
		obj.clborders = new ArrayList<ClauseBorder>();
		
		if (obj.cls.getTypeFromStack(1).equals("SCOC")){
			spos=obj.cls.getIndexFromStack(1);
		}

		if (obj.cls.stackSize()>0 && spos < obj.cls.getIndexFromStack(1)) 
			spos = obj.cls.getIndexFromStack(1);

		
		if (chooseFirstComma) {
			for (int i=spos; i<epos+1; i++) {
				
				Word t = sentence.get(i);

				if (commas.contains(t.wordform)) {
					
					if (obj.cls.getTypeFromStack(1).endsWith("COS")) {
						
						obj.clborders.add(new ClauseBorder(i, "CC"));
						obj.cls.removeFromStack();
						
						while (obj.cls.size()>0 && verbIsPresent(sentence, verbs, 
								obj.cls
									.getIndexFromStack(1),i)){
							
							obj.clborders.add(new ClauseBorder(i, "CC"));
							obj.cls.removeFromStack();
							
						}

						
						if (obj.cls.size() == 0){
							obj.clborders.add(new ClauseBorder(i+1, "COC"));
							obj.cls.putInStack("COC", i+1);
						}
						
						if (i<sentence.size()-1
								&& sentence.get(i+1).pos.equals("C")){
							obj.clborders.add(new ClauseBorder(i+1, "COC"));
							obj.cls.putInStack("COC", i+1);
						}
	
					} 

					
					
					break;
				}
				
			}

		} else {
			for (int i=epos; i>spos-1; i--) {
				
				Word t = sentence.get(i);

				if (commas.contains(t.wordform)) {
					
					if (obj.cls.getTypeFromStack(1).endsWith("COS")) {
						
						while (obj.cls.size()>0 && verbIsPresent(sentence, verbs, 
								obj.cls
									.getIndexFromStack(1),i)){
							
							obj.clborders.add(new ClauseBorder(i, "CC"));
							obj.cls.removeFromStack();
							
						}
						
						if (obj.cls.size() == 0){
							obj.clborders.add(new ClauseBorder(i+1, "COC"));
							obj.cls.putInStack("COC", i+1);
						}
						
						if (i<sentence.size()-1
								&& sentence.get(i+1).pos.equals("C")){
							obj.clborders.add(new ClauseBorder(i+1, "COC"));
							obj.cls.putInStack("COC", i+1);
						}

						
					} 
					
					break;
				}
				
			}

		}
				

		return obj;

		
	}
	
	public boolean isEnding(){
		return isEndingRule;
	}

	public boolean verbIsPresent(Sentence sent, 
			ArrayList<ClauseVerb> verbs, int begin, int end){
		
		
		
		int vind = -1;
		for (VerbForm vf : verbs) {
			if (begin <= vf.get(0).sentpos && vf.get(vf.size()-1).sentpos <= end
					&& sent.get(vf.get(0).sentpos).clauseID.equals(sent.get(begin).clauseID)) {
		
				System.out.println("VC: begin "+begin + " end "+end);
				System.out.println("VC: "+sent.get(vf.get(0).sentpos).wordform + " "+sent.get(vf.get(0).sentpos).clauseID);
				System.out.println("VC: "+sent.get(begin).wordform + " "+sent.get(begin).clauseID);
				vind = vf.get(vf.size()-1).sentpos;
				break;
			}
		}
		
		if (vind > -1 && vind < end) return true;
		
		return false;
	}

	
}
